package main

import (
	"context"
	"fmt"
	"net/http"
)

type Context struct {
	User string
}

func HTTP(port int, db DB) error {
	foo := func(w http.ResponseWriter, r *http.Request) {
	}
	foo = withAuth(foo)
	return http.ListenAndServe(fmt.Sprintf(":%d", port), http.HandlerFunc(foo))
}

func extract(ctx context.Context) Context {
	v := ctx.Value("__context")
	v2, _ := v.(Context)
	return v2
}

func inject(ctx context.Context, v Context) context.Context {
	return context.WithValue(ctx, "__context", v)
}

func withAuth(foo http.HandlerFunc) http.HandlerFunc {
	return func(w http.ResponseWriter, r *http.Request) {
		u, _, ok := r.BasicAuth()
		if !ok || u == "" {
			w.Header().Set("WWW-Authenticate", "Basic")
			w.WriteHeader(401)
			return
		}
		c := extract(r.Context())
		c.User = u
		r = r.WithContext(inject(r.Context(), c))
		foo(w, r)
	}
}
